Index: palm/trunk/SOURCE/shared_memory_io_mod.f90
===================================================================
--- palm/trunk/SOURCE/shared_memory_io_mod.f90	(revision 4892)
+++ palm/trunk/SOURCE/shared_memory_io_mod.f90	(revision 4893)
@@ -1169,4 +1327,92 @@
  END SUBROUTINE sm_allocate_shared_3di_64
 
+
+!--------------------------------------------------------------------------------------------------!
+! Description:
+! ------------
+!> Allocate shared 3d-REAL (64 Bit) array on ALL PEs.
+!>
+!> Every PE allocates the local part of a node-shared array.
+!> The C-Pointer of this array and the local limits are broadcasted to all PEs of the node
+!> The information is store in an array of type sm_remote_array and can be retrieved
+!> by sm_remote_array to access remote data.
+!--------------------------------------------------------------------------------------------------!
+ SUBROUTINE sm_all_allocate_shared_3d_64( this, p3, d1s, d1e, d2s, d2e, d3s, d3e, remote_arrays, win )
+
+    IMPLICIT NONE
+
+    CLASS(sm_class), INTENT(inout)      ::  this         !< class pointer
+    REAL(dp), DIMENSION(:,:,:), POINTER ::  p3           !< return local array pointer
+
+    INTEGER(iwp), INTENT(IN)            ::  d1e          !< end index dimension 1
+    INTEGER(iwp), INTENT(IN)            ::  d1s          !< start index dimension 1
+    INTEGER(iwp), INTENT(IN)            ::  d2e          !< end index dimension 2
+    INTEGER(iwp), INTENT(IN)            ::  d2s          !< start index dimension 2
+    INTEGER(iwp), INTENT(IN)            ::  d3e          !< end index dimension 3
+    INTEGER(iwp), INTENT(IN)            ::  d3s          !< start index dimension 3
+    INTEGER(iwp), INTENT(OUT)           ::  win          !< MPI Window
+
+    INTEGER(iwp), DIMENSION(3)          ::  buf_shape    !<
+    INTEGER(iwp)                        ::  disp_unit    !<
+    INTEGER(iwp)                        ::  i            !<
+    INTEGER(iwp), SAVE                  ::  pe_from = 0  !<
+
+    INTEGER(KIND=MPI_ADDRESS_KIND)      ::  rem_size     !<
+    INTEGER(KIND=MPI_ADDRESS_KIND)      ::  wsize        !<
+
+    REAL(dp), DIMENSION(:,:,:), POINTER ::  buf          !<
+
+    TYPE(sm_remote_array),INTENT(INOUT), DIMENSION(0:this%sh_npes-1) :: remote_arrays !< info about all remote arrays
+
+    TYPE(C_PTR), SAVE                   ::  base_ptr     !<
+
+    INTEGER(iwp),DIMENSION(6,0:this%sh_npes-1)              ::  all_indices_s
+    INTEGER(iwp),DIMENSION(6,0:this%sh_npes-1)              ::  all_indices
+
+
+    IF ( this%no_shared_memory_in_this_run )  RETURN
+
+    all_indices_s = 0
+
+
+    wsize = ( d3e - d3s + 1 ) * ( d2e - d2s + 1 ) * ( d1e - d1s + 1 )
+
+    wsize = wsize * dp   ! Please note, size is always in bytes, independently of the displacement unit
+
+    CALL MPI_WIN_ALLOCATE_SHARED( wsize, dp, MPI_INFO_NULL, this%comm_shared, base_ptr, win, ierr )
+!
+!-- Get C-pointer of the memory located on node-rank pe_from (sh_rank == pe_from)
+
+    all_indices_s(1,this%sh_rank) = d1s
+    all_indices_s(2,this%sh_rank) = d1e
+    all_indices_s(3,this%sh_rank) = d2s
+    all_indices_s(4,this%sh_rank) = d2e
+    all_indices_s(5,this%sh_rank) = d3s
+    all_indices_s(6,this%sh_rank) = d3e
+
+    CALL MPI_ALLREDUCE (all_indices_s ,all_indices, SIZE(all_indices_s), MPI_INTEGER, MPI_SUM, this%comm_shared, ierr)
+
+    DO i=0,this%sh_npes-1
+       CALL MPI_WIN_SHARED_QUERY( win, i, rem_size, disp_unit, remote_arrays(i)%rem_ptr, ierr )
+       remote_arrays(i)%d1s = all_indices(1,i)
+       remote_arrays(i)%d1e = all_indices(2,i)
+       remote_arrays(i)%d2s = all_indices(3,i)
+       remote_arrays(i)%d2e = all_indices(4,i)
+       remote_arrays(i)%d3s = all_indices(5,i)
+       remote_arrays(i)%d3e = all_indices(6,i)
+    END DO
+
+!
+!-- Convert C- to Fortran-pointer
+    buf_shape(3) = d3e - d3s + 1
+    buf_shape(2) = d2e - d2s + 1
+    buf_shape(1) = d1e - d1s + 1
+    CALL C_F_POINTER( remote_arrays(this%sh_rank)%rem_ptr, buf, buf_shape )
+    p3(d1s:,d2s:,d3s:) => buf
+!
+!-- Allocate shared memory in round robin on all PEs of a node.
+    pe_from = MOD( pe_from, this%sh_npes )
+
+ END SUBROUTINE sm_all_allocate_shared_3d_64
 #endif
 
@@ -1243,7 +1489,9 @@
 !> ...
 !--------------------------------------------------------------------------------------------------!
- SUBROUTINE sm_node_barrier( this )
-
-    IMPLICIT NONE
+ SUBROUTINE sm_node_barrier( this, win )
+
+    IMPLICIT NONE
+
+    INTEGER(iwp), OPTIONAL         ::  win   !<
 
     CLASS(sm_class), INTENT(inout) ::  this  !<
@@ -1254,4 +1502,7 @@
 #if defined( __parallel )
     CALL MPI_BARRIER( this%comm_shared, ierr )
+    IF ( PRESENT(win) )  THEN
+       CALL MPI_WIN_FENCE(0, win, ierr )
+    ENDIF
 #endif
 
Index: palm/trunk/SOURCE/surface_data_output_mod.f90
===================================================================
--- palm/trunk/SOURCE/surface_data_output_mod.f90	(revision 4892)
+++ palm/trunk/SOURCE/surface_data_output_mod.f90	(revision 4893)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! revised output of surface data via MPI-IO for better performance
+!
+! 4892 2021-03-02 11:53:58Z suehring
 ! Remove outdated error message.
 !
@@ -4578,5 +4581,6 @@
 
     INTEGER(iwp), DIMENSION(:,:), ALLOCATABLE ::  end_index           !< end index of surface data at (j,i)
-    INTEGER(iwp), DIMENSION(:,:), ALLOCATABLE ::  global_start_index  !< index array for surface data (MPI-IO)
+    INTEGER(iwp), DIMENSION(:,:), ALLOCATABLE ::  global_end_index    !< end index array for surface data (MPI-IO)
+    INTEGER(iwp), DIMENSION(:,:), ALLOCATABLE ::  global_start_index  !< start index array for surface data (MPI-IO)
     INTEGER(iwp), DIMENSION(:,:), ALLOCATABLE ::  num_surf            !< number of surface data at (j,i)
     INTEGER(iwp), DIMENSION(:,:), ALLOCATABLE ::  start_index         !< start index of surface data at (j,i)
@@ -4600,14 +4604,12 @@
     ALLOCATE( surf_in(1:surfaces%ns) )
 
-    CALL rd_mpi_io_check_array( 'surfaces%start_index', found = array_found )
-    IF ( array_found )  CALL rrd_mpi_io( 'surfaces%start_index', start_index )
-
-    CALL rd_mpi_io_check_array( 'surfaces%end_index', found = array_found )
-    IF ( array_found )  CALL rrd_mpi_io( 'surfaces%end_index', end_index )
-
     CALL rd_mpi_io_check_array( 'surfaces%global_start_index', found = array_found )
     IF ( array_found )  CALL rrd_mpi_io( 'surfaces%global_start_index', global_start_index )
 
-    CALL rd_mpi_io_surface_filetypes( start_index, end_index, ldum, global_start_index )
+    CALL rd_mpi_io_check_array( 'surfaces%global_end_index', found = array_found )
+    IF ( array_found )  CALL rrd_mpi_io( 'surfaces%global_end_index', global_end_index )
+
+    CALL rd_mpi_io_surface_filetypes( start_index, end_index, ldum, global_start_index,            &
+                                      global_end_index )
 
     DO  nv = 1, dosurf_no(1)
@@ -4728,5 +4730,6 @@
 
     INTEGER(iwp), DIMENSION(:,:), ALLOCATABLE ::  end_index           !< end index of surface data at (j,i)
-    INTEGER(iwp), DIMENSION(:,:), ALLOCATABLE ::  global_start_index  !< index array for surface data (MPI-IO)
+    INTEGER(iwp), DIMENSION(:,:), ALLOCATABLE ::  global_end_index    !< end index array for surface data (MPI-IO)
+    INTEGER(iwp), DIMENSION(:,:), ALLOCATABLE ::  global_start_index  !< start index array for surface data (MPI-IO)
     INTEGER(iwp), DIMENSION(:,:), ALLOCATABLE ::  num_surf            !< number of surface data at (j,i)
     INTEGER(iwp), DIMENSION(:,:), ALLOCATABLE ::  start_index         !< start index of surface data at (j,i)
@@ -4811,8 +4814,8 @@
 
           CALL rd_mpi_io_surface_filetypes( start_index, end_index, surface_data_to_write,         &
-                                            global_start_index )
-          CALL wrd_mpi_io( 'surfaces%start_index',        start_index        )
-          CALL wrd_mpi_io( 'surfaces%end_index',          end_index          )
+                                            global_start_index, global_end_index )
+
           CALL wrd_mpi_io( 'surfaces%global_start_index', global_start_index )
+          CALL wrd_mpi_io( 'surfaces%global_end_index', global_end_index )
 
           DO  nv = 1, dosurf_no(1)
Index: palm/trunk/SOURCE/surface_mod.f90
===================================================================
--- palm/trunk/SOURCE/surface_mod.f90	(revision 4892)
+++ palm/trunk/SOURCE/surface_mod.f90	(revision 4893)
@@ -25,10 +25,11 @@
 ! -----------------
 ! $Id$
+! revised output of surface data via MPI-IO for better performance
+!
+! 4882 2021-02-19 22:49:44Z forkel
 ! removed lsp in subroutine nitialize_top
-!
 !
 ! 4881 2021-02-19 22:05:08Z forkel
 ! removed constant_top_csflux option
-!
 !
 ! 4877 2021-02-17 16:17:35Z suehring
@@ -1484,5 +1485,6 @@
 !> Allocating memory for upward and downward-facing horizontal surface types, except for top fluxes.
 !--------------------------------------------------------------------------------------------------!
- SUBROUTINE allocate_surface_attributes_h( surfaces, nys_l, nyn_l, nxl_l, nxr_l )
+ SUBROUTINE allocate_surface_attributes_h( surfaces, nys_l, nyn_l, nxl_l, nxr_l,                   &
+                                           no_allocate_index_arrays )
 
     IMPLICIT NONE
@@ -1493,9 +1495,18 @@
     INTEGER(iwp) ::  nxr_l  !< east bound of local 2d array start/end_index, is equal to nyn, except for restart-array
 
+    LOGICAL ::  allocate_index_arrays
+    LOGICAL, INTENT(IN), OPTIONAL  :: no_allocate_index_arrays
+
     TYPE(surf_type) ::  surfaces  !< respective surface type
 
+
+    IF ( PRESENT( no_allocate_index_arrays ) )  THEN
+       allocate_index_arrays = .NOT. no_allocate_index_arrays
+    ELSE
+       allocate_index_arrays = .TRUE.
+    ENDIF
 !
 !-- Allocate arrays for start and end index of horizontal surface type for each (j,i)-grid point.
-!-- This is required e.g. in diffion_x, which is called for each (j,i). In order to find the
+!-- This is required e.g. in diffusion_x, which is called for each (j,i). In order to find the
 !-- location where the respective flux is store within the surface-type, start- and end-index are
 !-- stored for each (j,i). For example, each (j,i) can have several entries where fluxes for
@@ -1503,8 +1514,10 @@
 !-- surfaces might exist for given (j,i). If no surface of respective type exist at current (j,i),
 !-- set indicies such that loop in diffusion routines will not be entered.
-    ALLOCATE ( surfaces%start_index(nys_l:nyn_l,nxl_l:nxr_l) )
-    ALLOCATE ( surfaces%end_index(nys_l:nyn_l,nxl_l:nxr_l) )
-    surfaces%start_index = 0
-    surfaces%end_index   = -1
+    IF ( allocate_index_arrays )  THEN
+       ALLOCATE( surfaces%start_index(nys_l:nyn_l,nxl_l:nxr_l) )
+       ALLOCATE( surfaces%end_index(nys_l:nyn_l,nxl_l:nxr_l)   )
+       surfaces%start_index = 0
+       surfaces%end_index   = -1
+    ENDIF
 !
 !-- Indices to locate surface element
@@ -2051,5 +2064,6 @@
 !> Allocating memory for vertical surface types.
 !--------------------------------------------------------------------------------------------------!
- SUBROUTINE allocate_surface_attributes_v( surfaces, nys_l, nyn_l, nxl_l, nxr_l )
+ SUBROUTINE allocate_surface_attributes_v( surfaces, nys_l, nyn_l, nxl_l, nxr_l,                   &
+                                           no_allocate_index_arrays )
 
     IMPLICIT NONE
@@ -2060,17 +2074,29 @@
     INTEGER(iwp) ::  nxr_l  !< east bound of local 2d array start/end_index, is equal to nyn, except for restart-array
 
+    LOGICAL ::  allocate_index_arrays
+    LOGICAL, INTENT(IN), OPTIONAL ::  no_allocate_index_arrays
+
     TYPE(surf_type) ::  surfaces !< respective surface type
 
+
+    IF ( PRESENT( no_allocate_index_arrays ) )  THEN
+       allocate_index_arrays = .NOT. no_allocate_index_arrays
+    ELSE
+       allocate_index_arrays = .TRUE.
+    ENDIF
+
 !
 !-- Allocate arrays for start and end index of vertical surface type for each (j,i)-grid point. This
-!-- is required in diffion_x, which is called for each (j,i). In order to find the location where
+!-- is required in diffusion_x, which is called for each (j,i). In order to find the location where
 !-- the respective flux is store within the surface-type, start- and end-index are stored for each
 !-- (j,i). For example, each (j,i) can have several entries where fluxes for vertical surfaces might
 !-- be stored. In the flat case, where no vertical walls exit, set indicies such that loop in
 !-- diffusion routines will not be entered.
-    ALLOCATE ( surfaces%start_index(nys_l:nyn_l,nxl_l:nxr_l) )
-    ALLOCATE ( surfaces%end_index(nys_l:nyn_l,nxl_l:nxr_l) )
-    surfaces%start_index = 0
-    surfaces%end_index   = -1
+    IF ( allocate_index_arrays )  THEN
+       ALLOCATE( surfaces%start_index(nys_l:nyn_l,nxl_l:nxr_l) )
+       ALLOCATE( surfaces%end_index(nys_l:nyn_l,nxl_l:nxr_l)   )
+       surfaces%start_index = 0
+       surfaces%end_index   = -1
+    ENDIF
 !
 !-- Indices to locate surface element.
@@ -3141,5 +3167,6 @@
     INTEGER(iwp), DIMENSION(0:3) ::  start_index_v  !< start index for vertical surface elements on gathered surface array
 
-    INTEGER(iwp),DIMENSION(nys:nyn,nxl:nxr) ::  global_start_index  !< index for surface data (MPI-IO)
+    INTEGER(iwp),DIMENSION(nys:nyn,nxl:nxr) ::  global_end_index    !< end index for surface data (MPI-IO)
+    INTEGER(iwp),DIMENSION(nys:nyn,nxl:nxr) ::  global_start_index  !< start index for surface data (MPI-IO)
 
     LOGICAL ::  surface_data_to_write  !< switch for MPI-I/O if PE has surface data to write
@@ -3988,12 +4015,12 @@
 
           CALL rd_mpi_io_surface_filetypes( surf_h(l)%start_index, surf_h(l)%end_index,            &
-                                            surface_data_to_write, global_start_index )
+                                            surface_data_to_write, global_start_index,             &
+                                            global_end_index )
           IF ( .NOT. surface_data_to_write )  CYCLE
 
           ns_h_on_file(l) = total_number_of_surface_values
 
-          CALL wrd_mpi_io( 'surf_h(' // dum // ')%start_index', surf_h(l)%start_index )
-          CALL wrd_mpi_io( 'surf_h(' // dum // ')%end_index', surf_h(l)%end_index )
           CALL wrd_mpi_io( 'global_start_index_h_' // dum, global_start_index )
+          CALL wrd_mpi_io( 'global_end_index_h_' // dum, global_end_index )
 
           IF ( ALLOCATED ( surf_h(l)%us ) )  THEN
@@ -4121,11 +4148,13 @@
 
           CALL rd_mpi_io_surface_filetypes( surf_v(l)%start_index, surf_v(l)%end_index,            &
-                                            surface_data_to_write, global_start_index )
+                                            surface_data_to_write, global_start_index,             &
+                                            global_end_index )
+
+          IF ( .NOT. surface_data_to_write )  CYCLE
 
           ns_v_on_file(l) = total_number_of_surface_values
 
-          CALL wrd_mpi_io( 'surf_v(' // dum // ')%start_index', surf_v(l)%start_index )
-          CALL wrd_mpi_io( 'surf_v(' // dum // ')%end_index', surf_v(l)%end_index )
           CALL wrd_mpi_io( 'global_start_index_v_' // dum, global_start_index )
+          CALL wrd_mpi_io( 'global_end_index_v_' // dum, global_end_index )
 
           IF ( .NOT. surface_data_to_write )  CYCLE
@@ -5381,7 +5410,8 @@
     INTEGER(iwp) ::  mm !< loop index for surface types - file array
 
-    INTEGER(iwp), DIMENSION(nys:nyn,nxl:nxr) ::  global_start_index  !< index for surface data (MPI-IO)
-
-    LOGICAL ::  ldum            !< dummy variable
+    INTEGER(iwp), DIMENSION(nys:nyn,nxl:nxr) ::  global_end_index    !< end index for surface data (MPI-IO)
+    INTEGER(iwp), DIMENSION(nys:nyn,nxl:nxr) ::  global_start_index  !< start index for surface data (MPI-IO)
+
+    LOGICAL ::  data_to_read    !< cycle in l loop, if no values to read
     LOGICAL ::  surf_match_def  !< flag indicating that surface element is of default type
     LOGICAL ::  surf_match_lsm  !< flag indicating that surface element is of natural type
@@ -5401,16 +5431,24 @@
        IF ( ns_h_on_file(l) == 0 )  CYCLE  !< No data of this surface type on file
 
+       WRITE( dum, '(I1)')  l
+
        IF ( ALLOCATED( surf_h(l)%start_index ) )  CALL deallocate_surface_attributes_h( surf_h(l) )
-       surf_h(l)%ns = ns_h_on_file(l)
-       CALL allocate_surface_attributes_h( surf_h(l), nys, nyn, nxl, nxr )
-
-       WRITE( dum, '(I1)') l
-
-       CALL rrd_mpi_io( 'surf_h(' // dum // ')%start_index',  surf_h(l)%start_index )
-       CALL rrd_mpi_io( 'surf_h(' // dum // ')%end_index',  surf_h(l)%end_index )
+
+       ALLOCATE( surf_h(l)%start_index(nys:nyn,nxl:nxr) )
+       ALLOCATE( surf_h(l)%end_index(nys:nyn,nxl:nxr) )
+       surf_h(l)%start_index = 0
+       surf_h(l)%end_index   = -1
+
        CALL rrd_mpi_io( 'global_start_index_h_' // dum , global_start_index )
-
-       CALL rd_mpi_io_surface_filetypes( surf_h(l)%start_index, surf_h(l)%end_index, ldum,         &
-                                         global_start_index )
+       CALL rrd_mpi_io( 'global_end_index_h_' // dum , global_end_index )
+
+       CALL rd_mpi_io_surface_filetypes( surf_h(l)%start_index, surf_h(l)%end_index, data_to_read, &
+                                         global_start_index, global_end_index )
+
+       surf_h(l)%ns = MAX( 2, MAXVAL( surf_h(l)%end_index ) )
+
+       CALL allocate_surface_attributes_h( surf_h(l), nys, nyn, nxl, nxr,                          &
+                                           no_allocate_index_arrays = .TRUE. )
+       IF ( .NOT. data_to_read )  CYCLE
 
        IF ( ALLOCATED ( surf_h(l)%us ) )  THEN
@@ -5539,15 +5577,22 @@
 
        IF ( ALLOCATED( surf_v(l)%start_index ) )  CALL deallocate_surface_attributes_v( surf_v(l) )
-       surf_v(l)%ns = ns_v_on_file(l)
-       CALL allocate_surface_attributes_v( surf_v(l), nys, nyn, nxl, nxr )
-
-       WRITE( dum, '(I1)' ) l
-
-       CALL rrd_mpi_io( 'surf_v(' // dum // ')%start_index', surf_v(l)%start_index )
-       CALL rrd_mpi_io( 'surf_v(' // dum // ')%end_index', surf_v(l)%end_index )
+
+       ALLOCATE( surf_v(l)%start_index(nys:nyn,nxl:nxr) )
+       ALLOCATE( surf_v(l)%end_index(nys:nyn,nxl:nxr) )
+       surf_v(l)%start_index = 0
+       surf_v(l)%end_index   = -1
+
+       WRITE( dum, '(I1)' )  l
+
        CALL rrd_mpi_io( 'global_start_index_v_' // dum , global_start_index )
-
-       CALL rd_mpi_io_surface_filetypes( surf_v(l)%start_index, surf_v(l)%end_index, ldum,         &
-                                         global_start_index )
+       CALL rrd_mpi_io( 'global_end_index_v_' // dum , global_end_index )
+
+       CALL rd_mpi_io_surface_filetypes( surf_v(l)%start_index, surf_v(l)%end_index, data_to_read, &
+                                         global_start_index, global_end_index )
+       IF ( .NOT. data_to_read )  CYCLE
+
+       surf_v(l)%ns = MAX( 2, MAXVAL( surf_v(l)%end_index ) )
+       CALL allocate_surface_attributes_v( surf_v(l), nys, nyn, nxl, nxr,                          &
+                                           no_allocate_index_arrays = .TRUE.  )
 
        IF ( ALLOCATED ( surf_v(l)%us ) )  THEN
